"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExecutionCanvas = ExecutionCanvas;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _antd() {
  const data = require("antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _reactRouterDom() {
  const data = require("react-router-dom");
  _reactRouterDom = function _reactRouterDom() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _client2() {
  const data = require("@nocobase/utils/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
var _FlowContext = require("./FlowContext");
var _style = require("./style");
var _constants = require("./constants");
var _locale = require("./locale");
var _utils = require("./utils");
var _nodes = require("./nodes");
var _CanvasContent = require("./CanvasContent");
const _excluded = ["nodes", "revisions"],
  _excluded2 = ["jobs", "workflow"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function attachJobs(nodes, jobs = []) {
  const nodesMap = new Map();
  nodes.forEach(item => {
    item.jobs = [];
    nodesMap.set(item.id, item);
  });
  jobs.forEach(item => {
    const node = nodesMap.get(item.nodeId);
    node.jobs.push(item);
    item.node = {
      id: node.id,
      title: node.title,
      type: node.type
    };
  });
  nodes.forEach(item => {
    item.jobs = item.jobs.sort((a, b) => a.id - b.id);
  });
}
function JobModal() {
  const compile = (0, _client().useCompile)();
  const _useFlowContext = (0, _FlowContext.useFlowContext)(),
    job = _useFlowContext.viewJob,
    setViewJob = _useFlowContext.setViewJob;
  const _ref = job !== null && job !== void 0 ? job : {},
    _ref$node = _ref.node,
    node = _ref$node === void 0 ? {} : _ref$node;
  const instruction = _nodes.instructions.get(node.type);
  return _react().default.createElement(_client().ActionContextProvider, {
    value: {
      visible: Boolean(job),
      setVisible: setViewJob
    }
  }, _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [`${job === null || job === void 0 ? void 0 : job.id}-modal`]: {
          type: 'void',
          'x-decorator': 'Form',
          'x-decorator-props': {
            initialValue: job
          },
          'x-component': 'Action.Modal',
          title: _react().default.createElement("div", {
            className: _style.nodeTitleClass
          }, _react().default.createElement(_antd().Tag, null, compile(instruction === null || instruction === void 0 ? void 0 : instruction.title)), _react().default.createElement("strong", null, node.title), _react().default.createElement("span", {
            className: "workflow-node-id"
          }, "#", node.id)),
          properties: {
            status: {
              type: 'number',
              title: `{{t("Status", { ns: "${_locale.NAMESPACE}" })}}`,
              'x-decorator': 'FormItem',
              'x-component': 'Select',
              enum: _constants.JobStatusOptions,
              'x-read-pretty': true
            },
            updatedAt: {
              type: 'string',
              title: `{{t("Executed at", { ns: "${_locale.NAMESPACE}" })}}`,
              'x-decorator': 'FormItem',
              'x-component': 'DatePicker',
              'x-component-props': {
                showTime: true
              },
              'x-read-pretty': true
            },
            result: {
              type: 'object',
              title: `{{t("Node result", { ns: "${_locale.NAMESPACE}" })}}`,
              'x-decorator': 'FormItem',
              'x-component': 'Input.JSON',
              'x-component-props': {
                className: (0, _css().css)`
                      padding: 1em;
                      background-color: #eee;
                    `
              },
              'x-read-pretty': true
            }
          }
        }
      }
    }
  }));
}
function ExecutionCanvas() {
  var _data$data2;
  const compile = (0, _client().useCompile)();
  const _useResourceActionCon = (0, _client().useResourceActionContext)(),
    data = _useResourceActionCon.data,
    loading = _useResourceActionCon.loading;
  const _useDocumentTitle = (0, _client().useDocumentTitle)(),
    setTitle = _useDocumentTitle.setTitle;
  const _useState = (0, _react().useState)(null),
    _useState2 = _slicedToArray(_useState, 2),
    viewJob = _useState2[0],
    setViewJob = _useState2[1];
  (0, _react().useEffect)(() => {
    var _data$data;
    const _ref2 = (_data$data = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data !== void 0 ? _data$data : {},
      workflow = _ref2.workflow;
    setTitle === null || setTitle === void 0 ? void 0 : setTitle(`${(workflow === null || workflow === void 0 ? void 0 : workflow.title) ? `${workflow.title} - ` : ''}${(0, _locale.lang)('Execution history')}`);
  }, [data === null || data === void 0 ? void 0 : data.data]);
  if (!(data === null || data === void 0 ? void 0 : data.data)) {
    if (loading) {
      return _react().default.createElement("div", null, (0, _locale.lang)('Loading'));
    } else {
      return _react().default.createElement("div", null, (0, _locale.lang)('Load failed'));
    }
  }
  const _ref3 = (_data$data2 = data === null || data === void 0 ? void 0 : data.data) !== null && _data$data2 !== void 0 ? _data$data2 : {},
    _ref3$jobs = _ref3.jobs,
    jobs = _ref3$jobs === void 0 ? [] : _ref3$jobs,
    _ref3$workflow = _ref3.workflow,
    _ref3$workflow2 = _ref3$workflow === void 0 ? {} : _ref3$workflow,
    _ref3$workflow2$nodes = _ref3$workflow2.nodes,
    nodes = _ref3$workflow2$nodes === void 0 ? [] : _ref3$workflow2$nodes,
    _ref3$workflow2$revis = _ref3$workflow2.revisions,
    revisions = _ref3$workflow2$revis === void 0 ? [] : _ref3$workflow2$revis,
    workflow = _objectWithoutProperties(_ref3$workflow2, _excluded),
    execution = _objectWithoutProperties(_ref3, _excluded2);
  (0, _utils.linkNodes)(nodes);
  attachJobs(nodes, jobs);
  const entry = nodes.find(item => !item.upstream);
  const statusOption = _constants.ExecutionStatusOptionsMap[execution.status];
  return _react().default.createElement(_FlowContext.FlowContext.Provider, {
    value: {
      workflow: workflow.type ? workflow : null,
      nodes,
      execution,
      viewJob,
      setViewJob
    }
  }, _react().default.createElement("div", {
    className: "workflow-toolbar"
  }, _react().default.createElement("header", null, _react().default.createElement(_antd().Breadcrumb, null, _react().default.createElement(_antd().Breadcrumb.Item, null, _react().default.createElement(_reactRouterDom().Link, {
    to: `/admin/settings/workflow/workflows`
  }, (0, _locale.lang)('Workflow'))), _react().default.createElement(_antd().Breadcrumb.Item, null, _react().default.createElement(_reactRouterDom().Link, {
    to: `/admin/settings/workflow/workflows/${workflow.id}`
  }, workflow.title)), _react().default.createElement(_antd().Breadcrumb.Item, null, _react().default.createElement("strong", null, `#${execution.id}`)))), _react().default.createElement("aside", null, _react().default.createElement(_antd().Tag, {
    color: statusOption.color
  }, compile(statusOption.label)), _react().default.createElement("time", null, (0, _client2().str2moment)(execution.updatedAt).format('YYYY-MM-DD HH:mm:ss')))), _react().default.createElement(_CanvasContent.CanvasContent, {
    entry: entry
  }), _react().default.createElement(JobModal, null));
}