"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CollectionBlockInitializer = CollectionBlockInitializer;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _utils = require("../nodes/manual/utils");
const _excluded = ["insert", "collection", "dataSource"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function InnerCollectionBlockInitializer(_ref) {
  let insert = _ref.insert,
    collection = _ref.collection,
    dataSource = _ref.dataSource,
    props = _objectWithoutProperties(_ref, _excluded);
  const _useSchemaTemplateMan = (0, _client().useSchemaTemplateManager)(),
    getTemplateSchemaByMode = _useSchemaTemplateMan.getTemplateSchemaByMode;
  const _useCollectionManager = (0, _client().useCollectionManager)(),
    getCollection = _useCollectionManager.getCollection;
  const items = (0, _client().useRecordCollectionDataSourceItems)('FormItem');
  const resovledCollection = getCollection(collection);
  function onConfirm(_x) {
    return _onConfirm.apply(this, arguments);
  }
  function _onConfirm() {
    _onConfirm = _asyncToGenerator(function* ({
      item
    }) {
      const template = item.template ? yield getTemplateSchemaByMode(item) : null;
      const result = {
        type: 'void',
        name: resovledCollection.name,
        title: resovledCollection.title,
        'x-decorator': 'DetailsBlockProvider',
        'x-decorator-props': {
          collection,
          dataSource
        },
        'x-component': 'CardItem',
        'x-component-props': {
          title: props.title
        },
        'x-designer': 'SimpleDesigner',
        properties: {
          grid: {
            type: 'void',
            'x-component': 'FormV2',
            'x-component-props': {
              useProps: '{{useDetailsBlockProps}}'
            },
            'x-read-pretty': true,
            properties: {
              grid: template || {
                type: 'void',
                'x-component': 'Grid',
                'x-initializer': 'ReadPrettyFormItemInitializers',
                properties: {}
              }
            }
          }
        }
      };
      (0, _utils.traverseSchema)(result, node => {
        if (node['x-uid']) {
          delete node['x-uid'];
        }
      });
      insert(result);
    });
    return _onConfirm.apply(this, arguments);
  }
  return _react().default.createElement(_client().SchemaInitializer.Item, _objectSpread(_objectSpread({}, props), {}, {
    onClick: onConfirm,
    items: items
  }));
}
function CollectionBlockInitializer(props) {
  return _react().default.createElement(_client().CollectionProvider, {
    collection: props.collection
  }, _react().default.createElement(InnerCollectionBlockInitializer, _objectSpread({}, props)));
}