"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormBlockInitializer = FormBlockInitializer;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _utils = require("./utils");
var _constants = require("../../constants");
var _locale = require("../../locale");
const _excluded = ["insert", "schema"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function InternalFormBlockInitializer(_ref) {
  let insert = _ref.insert,
    schema = _ref.schema,
    others = _objectWithoutProperties(_ref, _excluded);
  const _useSchemaTemplateMan = (0, _client().useSchemaTemplateManager)(),
    getTemplateSchemaByMode = _useSchemaTemplateMan.getTemplateSchemaByMode;
  const items = (0, _client().useRecordCollectionDataSourceItems)('FormItem');
  function onConfirm(_x) {
    return _onConfirm.apply(this, arguments);
  }
  function _onConfirm() {
    _onConfirm = _asyncToGenerator(function* ({
      item
    }) {
      const template = item.template ? yield getTemplateSchemaByMode(item) : null;
      const result = (0, _client().createFormBlockSchema)(_objectSpread(_objectSpread({
        actionInitializers: 'AddActionButton',
        actions: {
          resolve: {
            type: 'void',
            title: `{{t("Continue the process", { ns: "${_locale.NAMESPACE}" })}}`,
            'x-decorator': 'ManualActionStatusProvider',
            'x-decorator-props': {
              value: _constants.JOB_STATUS.RESOLVED
            },
            'x-component': 'Action',
            'x-component-props': {
              type: 'primary',
              useAction: '{{ useSubmit }}'
            },
            'x-designer': 'Action.Designer',
            'x-designer-props': {
              type: 'record'
            },
            'x-action': `${_constants.JOB_STATUS.RESOLVED}`
          }
        }
      }, schema), {}, {
        template
      }));
      delete result['x-acl-action-props'];
      delete result['x-acl-action'];
      const _Object$keys = Object.keys(result.properties),
        _Object$keys2 = _slicedToArray(_Object$keys, 1),
        formKey = _Object$keys2[0];
      result.properties[formKey].properties.actions['x-decorator'] = 'ActionBarProvider';
      (0, _utils.traverseSchema)(result, node => {
        if (node['x-uid']) {
          delete node['x-uid'];
        }
      });
      insert(result);
    });
    return _onConfirm.apply(this, arguments);
  }
  return _react().default.createElement(_client().SchemaInitializer.Item, _objectSpread(_objectSpread({}, others), {}, {
    onClick: onConfirm,
    items: items
  }));
}
function FormBlockInitializer(props) {
  var _props$schema;
  return _react().default.createElement(_client().CollectionProvider, {
    collection: (_props$schema = props.schema) === null || _props$schema === void 0 ? void 0 : _props$schema.collection
  }, _react().default.createElement(InternalFormBlockInitializer, _objectSpread({}, props)));
}