"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findSchema = findSchema;
exports.traverseSchema = traverseSchema;
function traverseSchema(schema, fn) {
  fn(schema);
  if (schema.properties) {
    Object.keys(schema.properties).forEach(key => {
      traverseSchema(schema.properties[key], fn);
    });
  }
}
function findSchema(schema, filter, onlyLeaf = false) {
  const result = [];
  if (!schema) {
    return result;
  }
  if (filter(schema) && (!onlyLeaf || !schema.properties)) {
    result.push(schema);
    return result;
  }
  if (schema.properties) {
    Object.keys(schema.properties).forEach(key => {
      result.push(...findSchema(schema.properties[key], filter));
    });
  }
  return result;
}