"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _antd() {
  const data = require("@formily/antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
var _locale = require("../locale");
var _variable = require("../variable");
var _default = {
  title: `{{t("HTTP request", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'request',
  group: 'extended',
  description: `{{t("Send HTTP request to a URL. You can use the variables in the upstream nodes as request headers, parameters and request body.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    method: {
      type: 'string',
      required: true,
      title: `{{t("HTTP method", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        showSearch: false,
        allowClear: false
      },
      enum: [{
        label: 'GET',
        value: 'GET'
      }, {
        label: 'POST',
        value: 'POST'
      }, {
        label: 'PUT',
        value: 'PUT'
      }, {
        label: 'PATCH',
        value: 'PATCH'
      }, {
        label: 'DELETE',
        value: 'DELETE'
      }],
      default: 'POST'
    },
    url: {
      type: 'string',
      required: true,
      title: `{{t("URL", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'Input',
      'x-component-props': {
        placeholder: 'https://www.nocobase.com',
        className: 'full-width'
      }
    },
    headers: {
      type: 'array',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      title: `{{t("Headers", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t('"Content-Type" only support "application/json", and no need to specify', { ns: "${_locale.NAMESPACE}" })}}`,
      items: {
        type: 'object',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            properties: {
              name: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Name")}}`
                }
              },
              value: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Variable.Input',
                'x-component-props': {
                  scope: _variable.useWorkflowVariableOptions,
                  useTypedConstant: true
                }
              },
              remove: {
                type: 'void',
                'x-decorator': 'FormItem',
                'x-component': 'ArrayItems.Remove'
              }
            }
          }
        }
      },
      properties: {
        add: {
          type: 'void',
          title: `{{t("Add request header", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-component': 'ArrayItems.Addition'
        }
      }
    },
    params: {
      type: 'array',
      'x-component': 'ArrayItems',
      'x-decorator': 'FormItem',
      title: `{{t("Parameters", { ns: "${_locale.NAMESPACE}" })}}`,
      items: {
        type: 'object',
        properties: {
          space: {
            type: 'void',
            'x-component': 'Space',
            properties: {
              name: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Input',
                'x-component-props': {
                  placeholder: `{{t("Name")}}`
                }
              },
              value: {
                type: 'string',
                'x-decorator': 'FormItem',
                'x-component': 'Variable.Input',
                'x-component-props': {
                  scope: _variable.useWorkflowVariableOptions,
                  useTypedConstant: true
                }
              },
              remove: {
                type: 'void',
                'x-decorator': 'FormItem',
                'x-component': 'ArrayItems.Remove'
              }
            }
          }
        }
      },
      properties: {
        add: {
          type: 'void',
          title: `{{t("Add parameter", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-component': 'ArrayItems.Addition'
        }
      }
    },
    data: {
      type: 'string',
      title: `{{t("Body", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'Variable.JSON',
      'x-component-props': {
        scope: _variable.useWorkflowVariableOptions,
        autoSize: {
          minRows: 10
        },
        placeholder: `{{t("Input request data", { ns: "${_locale.NAMESPACE}" })}}`,
        className: 'full-width'
      },
      description: `{{t("Only support standard JSON data", { ns: "${_locale.NAMESPACE}" })}}`
    },
    timeout: {
      type: 'number',
      title: `{{t("Timeout config", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-decorator-props': {},
      'x-component': 'InputNumber',
      'x-component-props': {
        addonAfter: `{{t("ms", { ns: "${_locale.NAMESPACE}" })}}`,
        min: 1,
        step: 1000,
        defaultValue: 5000
      }
    },
    ignoreFail: {
      type: 'boolean',
      title: `{{t("Ignore fail request and continue workflow", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Checkbox'
    }
  },
  view: {},
  scope: {},
  components: {
    ArrayItems: _antd().ArrayItems
  }
};
exports.default = _default;