"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _react2() {
  const data = require("@formily/react");
  _react2 = function _react2() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _FilterDynamicComponent = require("../components/FilterDynamicComponent");
var _CollectionFieldset = _interopRequireWildcard(require("../components/CollectionFieldset"));
var _utils = require("../utils");
var _locale = require("../locale");
var _collection = require("../schemas/collection");
var _RadioWithTooltip = require("../components/RadioWithTooltip");
const _excluded = ["onChange"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function IndividualHooksRadioWithTooltip(_ref) {
  let onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded);
  const form = (0, _react2().useForm)();
  const collection = form.values.collection;
  const fields = (0, _CollectionFieldset.useCollectionUIFields)(collection);
  const field = (0, _react2().useField)();
  function onValueChange({
    target
  }) {
    const valuesField = field.query('.values').take();
    if (!valuesField) {
      return;
    }
    const filteredValues = fields.reduce((result, item) => {
      if (item.name in valuesField.value && (target.value || !['hasOne', 'hasMany', 'belongsToMany'].includes(item.type))) {
        result[item.name] = valuesField.value[item.name];
      }
      return result;
    }, {});
    form.setValuesIn('params.values', filteredValues);
    onChange(target.value);
  }
  return _react().default.createElement(_RadioWithTooltip.RadioWithTooltip, _objectSpread(_objectSpread({}, props), {}, {
    onChange: onValueChange
  }));
}
var _default = {
  title: `{{t("Update record", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'update',
  group: 'collection',
  description: `{{t("Update records of a collection. You can use variables from upstream nodes as query conditions and field values.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    collection: _collection.collection,
    params: {
      type: 'object',
      properties: {
        individualHooks: {
          type: 'boolean',
          title: `{{t("Update mode", { ns: "${_locale.NAMESPACE}" })}}`,
          'x-decorator': 'FormItem',
          'x-component': 'IndividualHooksRadioWithTooltip',
          'x-component-props': {
            options: [{
              label: `{{t("Update in a batch", { ns: "${_locale.NAMESPACE}" })}}`,
              value: false,
              tooltip: `{{t("Update all eligible data at one time, which has better performance when the amount of data is large. But the updated data will not trigger other workflows, and will not record audit logs.", { ns: "${_locale.NAMESPACE}" })}}`
            }, {
              label: `{{t("Update one by one", { ns: "${_locale.NAMESPACE}" })}}`,
              value: true,
              tooltip: `{{t("The updated data can trigger other workflows, and the audit log will also be recorded. But it is usually only applicable to several or dozens of pieces of data, otherwise there will be performance problems.", { ns: "${_locale.NAMESPACE}" })}}`
            }]
          },
          default: false
        },
        filter: _objectSpread(_objectSpread({}, _collection.filter), {}, {
          title: `{{t("Only update records matching conditions", { ns: "${_locale.NAMESPACE}" })}}`,
          ['x-validator'](value) {
            return (0, _utils.isValidFilter)(value) ? '' : `{{t("Please add at least one condition", { ns: "${_locale.NAMESPACE}" })}}`;
          }
        }),
        values: _objectSpread(_objectSpread({}, _collection.values), {}, {
          'x-component-props': {
            filter(field) {
              var _this$params;
              return ((_this$params = this.params) === null || _this$params === void 0 ? void 0 : _this$params.individualHooks) || !['hasOne', 'hasMany', 'belongsToMany'].includes(field.type);
            }
          }
        })
      }
    }
  },
  view: {},
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FilterDynamicComponent: _FilterDynamicComponent.FilterDynamicComponent,
    CollectionFieldset: _CollectionFieldset.default,
    IndividualHooksRadioWithTooltip
  }
};
exports.default = _default;