"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.executionSchema = exports.executionCollection = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactRouterDom() {
  const data = require("react-router-dom");
  _reactRouterDom = function _reactRouterDom() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _constants = require("../constants");
var _locale = require("../locale");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const executionCollection = {
  name: 'executions',
  fields: [{
    interface: 'createdAt',
    type: 'datetime',
    // field: 'createdAt',
    name: 'createdAt',
    uiSchema: {
      type: 'datetime',
      title: `{{t("Triggered at", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-component': 'DatePicker',
      'x-component-props': {},
      'x-read-pretty': true
    }
  }, {
    interface: 'm2o',
    type: 'belongsTo',
    name: 'workflowId',
    uiSchema: {
      type: 'number',
      title: `{{t("Version", { ns: "${_locale.NAMESPACE}" })}}`,
      ['x-component']({
        value
      }) {
        const _useActionContext = (0, _client().useActionContext)(),
          setVisible = _useActionContext.setVisible;
        return _react().default.createElement(_reactRouterDom().Link, {
          to: `/admin/settings/workflow/workflows/${value}`,
          onClick: () => setVisible(false)
        }, `#${value}`);
      }
    }
  }, {
    type: 'number',
    name: 'status',
    interface: 'select',
    uiSchema: {
      title: `{{t("Status", { ns: "${_locale.NAMESPACE}" })}}`,
      type: 'string',
      'x-component': 'Select',
      'x-decorator': 'FormItem',
      enum: _constants.ExecutionStatusOptions
    }
  }]
};
exports.executionCollection = executionCollection;
const executionSchema = {
  type: 'void',
  name: 'executionHistoryDrawer',
  title: `{{t("Execution history", { ns: "${_locale.NAMESPACE}" })}}`,
  'x-component': 'Action.Drawer',
  properties: {
    content: {
      type: 'void',
      'x-decorator': 'ExecutionResourceProvider',
      'x-decorator-props': {
        collection: executionCollection,
        resourceName: 'executions',
        request: {
          resource: 'executions',
          action: 'list',
          params: {
            appends: ['workflow.id', 'workflow.title'],
            pageSize: 20,
            sort: ['-createdAt'],
            filter: {}
          }
        }
      },
      properties: {
        actions: {
          type: 'void',
          'x-component': 'ActionBar',
          'x-component-props': {
            style: {
              marginBottom: 16
            }
          },
          properties: {
            // filter: {
            //   type: 'object',
            //   'x-component': 'Filter',
            // }
          }
        },
        table: {
          type: 'void',
          'x-component': 'Table.Void',
          'x-component-props': {
            rowKey: 'id',
            useDataSource: '{{ cm.useDataSourceFromRAC }}'
          },
          properties: {
            createdAt: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                createdAt: {
                  type: 'datetime',
                  'x-component': 'CollectionField',
                  'x-component-props': {
                    showTime: true
                  },
                  'x-read-pretty': true
                }
              }
            },
            workflowId: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                workflowId: {
                  type: 'number',
                  'x-component': 'CollectionField',
                  'x-read-pretty': true
                }
              }
            },
            status: {
              type: 'void',
              'x-decorator': 'Table.Column.Decorator',
              'x-component': 'Table.Column',
              properties: {
                status: {
                  type: 'number',
                  'x-component': 'CollectionField',
                  'x-read-pretty': true
                }
              }
            },
            actions: {
              type: 'void',
              title: '{{ t("Actions") }}',
              'x-component': 'Table.Column',
              properties: {
                actions: {
                  type: 'void',
                  'x-component': 'Space',
                  'x-component-props': {
                    split: '|'
                  },
                  properties: {
                    config: {
                      type: 'void',
                      title: `{{t("Details", { ns: "${_locale.NAMESPACE}" })}}`,
                      'x-component': 'ExecutionLink'
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
};
exports.executionSchema = executionSchema;