"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _winston() {
  const data = _interopRequireDefault(require("winston"));
  _winston = function _winston() {
    return data;
  };
  return data;
}
function _lruCache() {
  const data = _interopRequireDefault(require("lru-cache"));
  _lruCache = function _lruCache() {
    return data;
  };
  return data;
}
function _database() {
  const data = require("@nocobase/database");
  _database = function _database() {
    return data;
  };
  return data;
}
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@nocobase/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
var _fields = _interopRequireDefault(require("./fields"));
var _actions = _interopRequireDefault(require("./actions"));
var _constants = require("./constants");
var _instructions = _interopRequireDefault(require("./instructions"));
var _Processor = _interopRequireDefault(require("./Processor"));
var _triggers = _interopRequireDefault(require("./triggers"));
var _functions = _interopRequireDefault(require("./functions"));
function _logger() {
  const data = require("@nocobase/logger");
  _logger = function _logger() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
class WorkflowPlugin extends _server().Plugin {
  constructor(...args) {
    var _this;
    super(...args);
    _this = this;
    this.instructions = new (_utils().Registry)();
    this.triggers = new (_utils().Registry)();
    this.functions = new (_utils().Registry)();
    this.executing = null;
    this.pending = [];
    this.events = [];
    this.loggerCache = void 0;
    this.onBeforeSave = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (instance, options) {
        const Model = instance.constructor;
        if (instance.enabled) {
          instance.set('current', true);
        } else if (!instance.current) {
          const count = yield Model.count({
            where: {
              key: instance.key
            },
            transaction: options.transaction
          });
          if (!count) {
            instance.set('current', true);
          }
        }
        if (!instance.changed('enabled') || !instance.enabled) {
          return;
        }
        const previous = yield Model.findOne({
          where: {
            key: instance.key,
            current: true,
            id: {
              [_database().Op.ne]: instance.id
            }
          },
          transaction: options.transaction
        });
        if (previous) {
          // NOTE: set to `null` but not `false` will not violate the unique index
          yield previous.update({
            enabled: false,
            current: null
          }, {
            transaction: options.transaction,
            hooks: false
          });
          _this.toggle(previous, false);
        }
      });
      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();
    this.prepare = /*#__PURE__*/_asyncToGenerator(function* () {
      var _options$context;
      const event = _this.events.shift();
      if (!event) {
        return;
      }
      const _event = _slicedToArray(event, 3),
        workflow = _event[0],
        context = _event[1],
        options = _event[2];
      let valid = true;
      if ((_options$context = options.context) === null || _options$context === void 0 ? void 0 : _options$context.executionId) {
        // NOTE: no transaction here for read-uncommitted execution
        const existed = yield workflow.countExecutions({
          where: {
            id: options.context.executionId
          }
        });
        if (existed) {
          _this.getLogger(workflow.id).warn(`workflow ${workflow.id} has already been triggered in same execution (${options.context.executionId}), and newly triggering will be skipped.`);
          valid = false;
        }
      }
      if (valid) {
        const execution = yield _this.db.sequelize.transaction( /*#__PURE__*/function () {
          var _ref3 = _asyncToGenerator(function* (transaction) {
            const execution = yield workflow.createExecution({
              context,
              key: workflow.key,
              status: _constants.EXECUTION_STATUS.QUEUEING,
              useTransaction: workflow.useTransaction
            }, {
              transaction
            });
            const executed = yield workflow.countExecutions({
              transaction
            });
            // NOTE: not to trigger afterUpdate hook here
            yield workflow.increment('executed', {
              transaction
            });
            yield workflow.constructor.increment('allExecuted', {
              where: {
                key: workflow.key
              },
              transaction
            });
            execution.workflow = workflow;
            return execution;
          });
          return function (_x3) {
            return _ref3.apply(this, arguments);
          };
        }());
        _this.getLogger(workflow.id).debug(`execution of workflow ${workflow.id} created as ${execution.id}`, {
          data: execution.context
        });
        // NOTE: cache first execution for most cases
        if (!_this.executing && !_this.pending.length) {
          _this.pending.push([execution]);
        }
      }
      if (_this.events.length) {
        yield _this.prepare();
      } else {
        _this.dispatch();
      }
    });
  }
  getLogger(workflowId) {
    const now = new Date();
    const date = `${now.getFullYear()}-${`0${now.getMonth() + 1}`.slice(-2)}-${`0${now.getDate()}`.slice(-2)}`;
    const key = `${date}-${workflowId}}`;
    if (this.loggerCache.has(key)) {
      return this.loggerCache.get(key);
    }
    const logger = (0, _logger().createLogger)({
      transports: ['console', new (_winston().default.transports.File)({
        filename: (0, _logger().getLoggerFilePath)('workflows', date, `${workflowId}.log`),
        level: (0, _logger().getLoggerLevel)()
      })]
    });
    this.loggerCache.set(key, logger);
    return logger;
  }
  load() {
    var _this2 = this;
    return _asyncToGenerator(function* () {
      const db = _this2.db,
        options = _this2.options;
      (0, _fields.default)(_this2);
      (0, _actions.default)(_this2);
      (0, _triggers.default)(_this2, options.triggers);
      (0, _instructions.default)(_this2, options.instructions);
      (0, _functions.default)(_this2, options.functions);
      _this2.loggerCache = new (_lruCache().default)({
        max: 20,
        updateAgeOnGet: true,
        dispose(logger) {
          logger.end();
        }
      });
      _this2.app.acl.registerSnippet({
        name: `pm.${_this2.name}.workflows`,
        actions: ['workflows:*', 'workflows.nodes:*', 'executions:list', 'executions:get', 'flow_nodes:update', 'flow_nodes:destroy']
      });
      _this2.app.acl.allow('users_jobs', ['list', 'get', 'submit'], 'loggedIn');
      yield db.import({
        directory: _path().default.resolve(__dirname, 'collections')
      });
      _this2.db.addMigrations({
        namespace: 'workflow',
        directory: _path().default.resolve(__dirname, 'migrations'),
        context: {
          plugin: _this2
        }
      });
      db.on('workflows.beforeSave', _this2.onBeforeSave);
      db.on('workflows.afterSave', model => _this2.toggle(model));
      db.on('workflows.afterDestroy', model => _this2.toggle(model, false));
      // [Life Cycle]:
      //   * load all workflows in db
      //   * add all hooks for enabled workflows
      //   * add hooks for create/update[enabled]/delete workflow to add/remove specific hooks
      _this2.app.on('beforeStart', /*#__PURE__*/_asyncToGenerator(function* () {
        const collection = db.getCollection('workflows');
        const workflows = yield collection.repository.find({
          filter: {
            enabled: true
          }
        });
        workflows.forEach(workflow => {
          _this2.toggle(workflow);
        });
      }));
      _this2.app.on('afterStart', () => {
        // check for not started executions
        _this2.dispatch();
      });
      _this2.app.on('beforeStop', /*#__PURE__*/_asyncToGenerator(function* () {
        const collection = db.getCollection('workflows');
        const workflows = yield collection.repository.find({
          filter: {
            enabled: true
          }
        });
        workflows.forEach(workflow => {
          _this2.toggle(workflow, false);
        });
      }));
    })();
  }
  toggle(workflow, enable) {
    const type = workflow.get('type');
    const trigger = this.triggers.get(type);
    if (typeof enable !== 'undefined' ? enable : workflow.get('enabled')) {
      // NOTE: remove previous listener if config updated
      const prev = workflow.previous();
      if (prev.config) {
        trigger.off(_objectSpread(_objectSpread({}, workflow.get()), prev));
      }
      trigger.on(workflow);
    } else {
      trigger.off(workflow);
    }
  }
  trigger(workflow, context, options = {}) {
    // `null` means not to trigger
    if (context == null) {
      return;
    }
    this.events.push([workflow, context, options]);
    this.getLogger(workflow.id).info(`new event triggered, now events: ${this.events.length}`);
    this.getLogger(workflow.id).debug(`event data:`, {
      data: context
    });
    if (this.events.length > 1) {
      return;
    }
    // NOTE: no await for quick return
    setTimeout(this.prepare);
  }
  resume(job) {
    var _this3 = this;
    return _asyncToGenerator(function* () {
      if (!job.execution) {
        job.execution = yield job.getExecution();
      }
      _this3.pending.push([job.execution, job]);
      _this3.dispatch();
    })();
  }
  dispatch() {
    var _this4 = this;
    return _asyncToGenerator(function* () {
      if (_this4.executing) {
        return;
      }
      let next = null;
      // resuming has high priority
      if (_this4.pending.length) {
        next = _this4.pending.shift();
      } else {
        const execution = yield _this4.db.getRepository('executions').findOne({
          filter: {
            status: _constants.EXECUTION_STATUS.QUEUEING
          },
          sort: 'createdAt'
        });
        if (execution) {
          next = [execution];
        }
      }
      if (next) {
        _this4.process(...next);
      }
    })();
  }
  process(execution, job) {
    var _this5 = this;
    return _asyncToGenerator(function* () {
      _this5.executing = execution;
      if (execution.status === _constants.EXECUTION_STATUS.QUEUEING) {
        yield execution.update({
          status: _constants.EXECUTION_STATUS.STARTED
        });
      }
      const processor = _this5.createProcessor(execution);
      _this5.getLogger(execution.workflowId).info(`execution (${execution.id}) ${job ? 'resuming' : 'starting'}...`);
      try {
        yield job ? processor.resume(job) : processor.start();
        _this5.getLogger(execution.workflowId).info(`execution (${execution.id}) finished with status: ${execution.status}`);
      } catch (err) {
        _this5.getLogger(execution.workflowId).error(`execution (${execution.id}) error: ${err.message}`, err);
      }
      _this5.executing = null;
      _this5.dispatch();
    })();
  }
  createProcessor(execution, options = {}) {
    return new _Processor.default(execution, _objectSpread(_objectSpread({}, options), {}, {
      plugin: this
    }));
  }
}
exports.default = WorkflowPlugin;