"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = {
  namespace: 'workflow.workflowConfig',
  duplicator: 'required',
  name: 'flow_nodes',
  fields: [{
    type: 'string',
    name: 'title'
  },
  // which workflow belongs to
  {
    name: 'workflow',
    type: 'belongsTo'
  }, {
    name: 'upstream',
    type: 'belongsTo',
    target: 'flow_nodes'
  }, {
    name: 'branches',
    type: 'hasMany',
    target: 'flow_nodes',
    sourceKey: 'id',
    foreignKey: 'upstreamId'
  },
  // only works when upstream node is branching type, such as condition and parallel.
  // put here because the design of flow-links model is not really necessary for now.
  // or it should be put into flow-links model.
  {
    name: 'branchIndex',
    type: 'integer'
  },
  // Note: for reasons:
  // 1. redirect type node to solve cycle flow.
  // 2. recognize as real next node after branches.
  {
    name: 'downstream',
    type: 'belongsTo',
    target: 'flow_nodes'
  }, {
    type: 'string',
    name: 'type'
  }, {
    type: 'json',
    name: 'config',
    defaultValue: {}
  }]
};
exports.default = _default;