import FlowNodeModel from '../models/FlowNode';
import Plugin from '..';
import Processor from '../Processor';
export declare type Job = {
    status: number;
    result?: unknown;
    [key: string]: unknown;
} | null;
export declare type InstructionResult = Job | Promise<Job>;
export declare type Runner = (node: FlowNodeModel, input: any, processor: Processor) => InstructionResult;
export interface Instruction {
    run: Runner;
    resume?: Runner;
    getScope?: (node: FlowNodeModel, job: any, processor: Processor) => any;
}
declare type InstructionConstructor<T> = {
    new (p: Plugin): T;
};
export default function <T extends Instruction>(plugin: any, more?: {
    [key: string]: T | InstructionConstructor<T>;
}): void;
export {};
