"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _axios() {
  const data = _interopRequireDefault(require("axios"));
  _axios = function _axios() {
    return data;
  };
  return data;
}
var _constants = require("../constants");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function request(_x) {
  return _request.apply(this, arguments);
}
function _request() {
  _request = _asyncToGenerator(function* (config) {
    var _config$headers, _config$params;
    // default headers
    const url = config.url,
      _config$method = config.method,
      method = _config$method === void 0 ? 'POST' : _config$method,
      data = config.data,
      _config$timeout = config.timeout,
      timeout = _config$timeout === void 0 ? 5000 : _config$timeout;
    const headers = ((_config$headers = config.headers) !== null && _config$headers !== void 0 ? _config$headers : []).reduce((result, header) => {
      if (header.name.toLowerCase() === 'content-type') {
        return result;
      }
      return Object.assign(result, {
        [header.name]: header.value
      });
    }, {});
    const params = ((_config$params = config.params) !== null && _config$params !== void 0 ? _config$params : []).reduce((result, param) => Object.assign(result, {
      [param.name]: param.value
    }), {});
    // TODO(feat): only support JSON type for now, should support others in future
    headers['Content-Type'] = 'application/json';
    return _axios().default.request({
      url,
      method,
      headers,
      params,
      data,
      timeout
    });
  });
  return _request.apply(this, arguments);
}
class _default {
  constructor(plugin) {
    this.plugin = void 0;
    this.plugin = plugin;
  }
  run(node, input, processor) {
    var _this = this;
    return _asyncToGenerator(function* () {
      const job = yield processor.saveJob({
        status: _constants.JOB_STATUS.PENDING,
        nodeId: node.id
      });
      const config = processor.getParsedValue(node.config, node);
      request(config).then(response => {
        job.set({
          status: _constants.JOB_STATUS.RESOLVED,
          result: response.data
        });
      }).catch(error => {
        job.set({
          status: _constants.JOB_STATUS.FAILED,
          result: error.isAxiosError ? error.toJSON() : error.message
        });
      }).finally(() => {
        processor.logger.info(`request (#${node.id}) response received, status: ${job.get('status')}`);
        _this.plugin.resume(job);
      });
      processor.logger.info(`request (#${node.id}) sent to "${config.url}", waiting for response...`);
      return processor.exit();
    })();
  }
  resume(node, job, processor) {
    return _asyncToGenerator(function* () {
      const ignoreFail = node.config.ignoreFail;
      if (ignoreFail) {
        job.set('status', _constants.JOB_STATUS.RESOLVED);
      }
      return job;
    })();
  }
}
exports.default = _default;