"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _lodash() {
  const data = require("lodash");
  _lodash = function _lodash() {
    return data;
  };
  return data;
}
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@nocobase/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
const _excluded = ["forms", "schema", "actions"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function findSchema(root, filter, onlyLeaf = false) {
  const result = [];
  if (!root) {
    return result;
  }
  if (filter(root) && (!onlyLeaf || !root.properties)) {
    result.push(root);
    return result;
  }
  if (root.properties) {
    Object.keys(root.properties).forEach(key => {
      result.push(...findSchema(root.properties[key], filter));
    });
  }
  return result;
}
function findParent(root, node) {
  return findSchema(root, item => item.properties && Object.values(item.properties).includes(node))[0];
}
// 1. all form blocks combine into one, at first form block position
// 2. add fields move to the form
// 3. remove all other form blocks except first (should remove ancestors till grid)
// 4. add 'x-interface-options' property to all fields as collection field
// 5. make collection fields decorator as `FormCollectionProvider` for form block
// 6. add form component wrapper for form grid
// 7. move action footer to form block
function migrateConfig({
  schema = {},
  actions = []
}) {
  const blocks = schema.blocks,
    collection = schema.collection;
  if (!blocks) {
    return {
      forms: {}
    };
  }
  const root = {
    properties: blocks
  };
  const formBlocks = findSchema(root, item => {
    return item['x-component'] === 'CardItem' && item['x-designer'] === 'SimpleDesigner' && item.properties.grid['x-initializer'] === 'AddFormField';
  });
  if (!formBlocks.length) {
    return {
      schema: blocks,
      forms: {}
    };
  }
  // 1.
  formBlocks.forEach((formBlock, i) => {
    const formItems = findSchema(formBlock, item => {
      return item['x-component'] === 'CollectionField' && item['x-decorator'] === 'FormItem';
    }, true);
    // 4.
    formItems.forEach(item => {
      Object.assign(item, {
        'x-interface-options': collection.fields.find(field => field.name === item.name)
      });
    });
    // skip first form block
    if (!i) {
      return;
    }
    // 2.
    Object.assign(formBlocks[0].properties.grid.properties, formBlock.properties.grid.properties);
    // 3.
    const col = findParent(root, formBlock);
    const row = findParent(root, col);
    delete row.properties[col.name];
    if (!Object.keys(row.properties).length) {
      const grid = findParent(root, row);
      delete grid.properties[row.name];
    }
  });
  // 5.
  const _formBlocks = _slicedToArray(formBlocks, 1),
    formBlock = _formBlocks[0];
  Object.assign(formBlock, {
    'x-decorator': 'FormCollectionProvider',
    'x-decorator-props': {
      collection
    },
    'x-component-props': {
      title: '{{t("Form")}}'
    },
    'x-designer-props': {
      type: 'customForm'
    }
  });
  const formId = (0, _utils().uid)();
  // 6.
  const newFormBlock = {
    [formId]: {
      type: 'void',
      'x-component': 'FormV2',
      'x-component-props': {
        useProps: '{{ useFormBlockProps }}'
      },
      properties: {
        grid: Object.assign(formBlock.properties.grid, {
          'x-initializer': 'AddCustomFormField'
        }),
        // 7.
        actions: {
          type: 'void',
          'x-decorator': 'ActionBarProvider',
          'x-component': 'ActionBar',
          'x-component-props': {
            layout: 'one-column',
            style: {
              marginTop: '1.5em'
            }
          },
          'x-initializer': 'AddActionButton',
          properties: schema.actions
        }
      }
    }
  };
  delete formBlock.properties.grid;
  Object.assign(formBlock.properties, newFormBlock);
  return {
    schema: blocks,
    forms: {
      [formId]: {
        type: 'custom',
        title: '{{t("Form")}}',
        actions,
        collection
      }
    }
  };
}
function migrateUsedConfig(config, manualForms) {
  Object.keys(config).forEach(key => {
    const valueType = typeof config[key];
    if (valueType === 'string') {
      config[key] = config[key].replace(/{{\s*\$jobsMapByNodeId\.(\d+)(\.[^}]+)?\s*}}/g, (matched, id, path) => {
        if (!manualForms[id]) {
          return matched;
        }
        return `{{$jobsMapByNodeId.${id}.${manualForms[id]}${path || ''}}}`;
      });
    } else if (valueType === 'object' && config[key]) {
      migrateUsedConfig(config[key], manualForms);
    }
  });
  return config;
}
class _default extends _server().Migration {
  up() {
    var _this = this;
    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<0.9.1-alpha.3');
      if (!match) {
        return;
      }
      const db = _this.context.db;
      const NodeRepo = db.getRepository('flow_nodes');
      const UserJobRepo = db.getRepository('users_jobs');
      yield db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: 'manual'
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => promise.then(() => {
            const _node$config = node.config,
              forms = _node$config.forms,
              schema = _node$config.schema,
              actions = _node$config.actions,
              config = _objectWithoutProperties(_node$config, _excluded);
            if (forms) {
              return;
            }
            return node.update({
              config: _objectSpread(_objectSpread({}, config), migrateConfig({
                schema,
                actions
              }))
            }, {
              silent: true,
              transaction
            });
          }), Promise.resolve());
          const usersJobs = yield UserJobRepo.find({
            filter: {
              nodeId: nodes.map(item => item.id)
            },
            appends: ['job', 'node'],
            transaction
          });
          // update all results
          yield usersJobs.reduce((promise, userJob) => promise.then( /*#__PURE__*/_asyncToGenerator(function* () {
            const result = userJob.result,
              job = userJob.job,
              node = userJob.node;
            const forms = node.config.forms;
            const _Object$keys = Object.keys(forms),
              _Object$keys2 = _slicedToArray(_Object$keys, 1),
              formId = _Object$keys2[0];
            if (result) {
              yield userJob.update({
                result: {
                  [formId]: result
                }
              }, {
                silent: true,
                transaction
              });
            }
            if (job.result) {
              yield job.update({
                result: {
                  [formId]: result
                }
              }, {
                silent: true,
                transaction
              });
            }
          })), Promise.resolve());
          const usedNodes = yield NodeRepo.find({
            filter: {
              type: {
                $notIn: ['delay', 'parallel']
              }
            },
            transaction
          });
          const nodeForms = {};
          nodes.forEach(node => {
            const _Object$keys3 = Object.keys(node.config.forms),
              _Object$keys4 = _slicedToArray(_Object$keys3, 1),
              form = _Object$keys4[0];
            if (form) {
              nodeForms[node.id] = form;
            }
          });
          yield usedNodes.reduce((promise, node) => promise.then( /*#__PURE__*/_asyncToGenerator(function* () {
            var _node$config2;
            yield node.update({
              config: migrateUsedConfig((0, _lodash().cloneDeep)((_node$config2 = node.config) !== null && _node$config2 !== void 0 ? _node$config2 : {}), nodeForms)
            }, {
              silent: true,
              transaction
            });
          })), Promise.resolve());
        });
        return function (_x2) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }
}
exports.default = _default;