"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@nocobase/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
const _excluded = ["schema"];
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function findSchema(root, filter, onlyLeaf = false) {
  const result = [];
  if (!root) {
    return result;
  }
  if (filter(root) && (!onlyLeaf || !root.properties)) {
    result.push(root);
    return result;
  }
  if (root.properties) {
    Object.keys(root.properties).forEach(key => {
      result.push(...findSchema(root.properties[key], filter));
    });
  }
  return result;
}
function migrateSchema(schema = {}) {
  const root = {
    properties: schema
  };
  const collectionBlocks = findSchema(root, item => {
    return item['x-component'] === 'CardItem' && item['x-designer'] === 'SimpleDesigner' && item['x-decorator'] === 'CollectionProvider';
  });
  collectionBlocks.forEach(block => {
    const id = (0, _utils().uid)();
    const grid = block.properties.grid;
    delete block.properties.grid;
    const fields = findSchema(grid, item => {
      return item['x-decorator'] === 'FormItem';
    });
    fields.forEach(field => {
      Object.assign(field, {
        'x-component': 'CollectionField',
        'x-collection-field': `${block['x-decorator-props'].collection}.${field['x-collection-field']}`
      });
    });
    Object.assign(block, {
      'x-decorator': 'DetailsBlockProvider',
      'x-decorator-props': _objectSpread(_objectSpread({}, block['x-decorator-props']), {}, {
        dataSource: grid['x-context-datasource']
      }),
      properties: {
        [id]: {
          type: 'void',
          name: id,
          'x-component': 'FormV2',
          'x-component-props': {
            useProps: '{{useDetailsBlockProps}}'
          },
          properties: {
            grid: {
              type: 'void',
              name: 'grid',
              'x-component': 'Grid',
              'x-initializer': 'ReadPrettyFormItemInitializers',
              properties: grid.properties
            }
          }
        }
      }
    });
  });
  const customForms = findSchema(root, item => {
    return item['x-decorator'] === 'FormCollectionProvider';
  });
  customForms.forEach(item => {
    Object.assign(item, {
      'x-decorator': 'CustomFormBlockProvider'
    });
  });
  const customFormFields = findSchema(root, item => {
    return item['x-interface-options'];
  });
  customFormFields.forEach(field => {
    const options = field['x-interface-options'];
    delete field['x-interface-options'];
    Object.assign(field, {
      'x-component-props': {
        field: options
      }
    });
  });
  return schema;
}
class _default extends _server().Migration {
  up() {
    var _this = this;
    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<0.9.4-alpha.3');
      if (!match) {
        return;
      }
      const db = _this.context.db;
      const NodeRepo = db.getRepository('flow_nodes');
      yield db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: 'manual'
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => promise.then(() => {
            const _node$config = node.config,
              schema = _node$config.schema,
              config = _objectWithoutProperties(_node$config, _excluded);
            node.set('config', _objectSpread(_objectSpread({}, config), {}, {
              schema: _objectSpread({}, migrateSchema(schema))
            }));
            node.changed('config', true);
            return node.save({
              silent: true,
              transaction
            });
          }), Promise.resolve());
        });
        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }
}
exports.default = _default;